<?php
/*
=====================================================
 DataLife Engine - by SoftNews Media Group 
-----------------------------------------------------
 http://www.pc-soft.ru/
-----------------------------------------------------
 Copyright (c) 2004,2005 SoftNews Media Group
=====================================================
     
=====================================================
 : parse.class.php
-----------------------------------------------------
 :  
=====================================================
*/

if(!defined('DATALIFEENGINE'))
{
  die("Hacking attempt!");
}

class ParseFilter {
	var $tagsArray;
	var $attrArray;
	var $tagsMethod;
	var $attrMethod;
	var $xssAuto;
	var $safe_mode = false;
	var $tagBlacklist = array('applet', 'body', 'bgsound', 'base', 'basefont', 'frame', 'frameset', 'head', 'html', 'id', 'iframe', 'ilayer', 'layer', 'link', 'meta', 'name', 'script', 'style', 'title', 'xml');
	var $attrBlacklist = array('action', 'background', 'codebase', 'dynsrc', 'lowsrc');

	function ParseFilter($tagsArray = array(), $attrArray = array(), $tagsMethod = 0, $attrMethod = 0, $xssAuto = 1) {		
		for ($i = 0; $i < count($tagsArray); $i++) $tagsArray[$i] = strtolower($tagsArray[$i]);
		for ($i = 0; $i < count($attrArray); $i++) $attrArray[$i] = strtolower($attrArray[$i]);
		$this->tagsArray = (array) $tagsArray;
		$this->attrArray = (array) $attrArray;
		$this->tagsMethod = $tagsMethod;
		$this->attrMethod = $attrMethod;
		$this->xssAuto = $xssAuto;
	}
	function process($source) {
		if (is_array($source)) {
			foreach($source as $key => $value)
				if (is_string($value)) $source[$key] = $this->remove($this->decode($value));
			return $source;
		} else if (is_string($source)) {
			return $this->remove($this->decode($source));
		} else return $source;	
	}
	function remove($source) {
		$loopCounter=0;
		while($source != $this->filterTags($source)) {
			$source = $this->filterTags($source);
			$loopCounter++;
		}
		return $source;
	}	
	function filterTags($source) {
		$preTag = NULL;
		$postTag = $source;
		$tagOpen_start = strpos($source, '<');
		while($tagOpen_start !== FALSE) {
			$preTag .= substr($postTag, 0, $tagOpen_start);
			$postTag = substr($postTag, $tagOpen_start);
			$fromTagOpen = substr($postTag, 1);
			$tagOpen_end = strpos($fromTagOpen, '>');
			if ($tagOpen_end === false) break;
			$tagOpen_nested = strpos($fromTagOpen, '<');
			if (($tagOpen_nested !== false) && ($tagOpen_nested < $tagOpen_end)) {
				$preTag .= substr($postTag, 0, ($tagOpen_nested+1));
				$postTag = substr($postTag, ($tagOpen_nested+1));
				$tagOpen_start = strpos($postTag, '<');
				continue;
			} 
			$tagOpen_nested = (strpos($fromTagOpen, '<') + $tagOpen_start + 1);
			$currentTag = substr($fromTagOpen, 0, $tagOpen_end);
			$tagLength = strlen($currentTag);
			if (!$tagOpen_end) {
				$preTag .= $postTag;
				$tagOpen_start = strpos($postTag, '<');			
			}
			$tagLeft = $currentTag;
			$attrSet = array();
			$currentSpace = strpos($tagLeft, ' ');
			if (substr($currentTag, 0, 1) == "/") {
				$isCloseTag = TRUE;
				list($tagName) = explode(' ', $currentTag);
				$tagName = substr($tagName, 1);
			} else {
				$isCloseTag = FALSE;
				list($tagName) = explode(' ', $currentTag);
			}		
			if ((!preg_match("/^[a-z][a-z0-9]*$/i",$tagName)) || (!$tagName) || ((in_array(strtolower($tagName), $this->tagBlacklist)) && ($this->xssAuto))) { 				
				$postTag = substr($postTag, ($tagLength + 2));
				$tagOpen_start = strpos($postTag, '<');
				continue;
			}
			while ($currentSpace !== FALSE) {
				$fromSpace = substr($tagLeft, ($currentSpace+1));
				$nextSpace = strpos($fromSpace, ' ');
				$openQuotes = strpos($fromSpace, '"');
				$closeQuotes = strpos(substr($fromSpace, ($openQuotes+1)), '"') + $openQuotes + 1;
				if (strpos($fromSpace, '=') !== FALSE) {
					if (($openQuotes !== FALSE) && (strpos(substr($fromSpace, ($openQuotes+1)), '"') !== FALSE))
						$attr = substr($fromSpace, 0, ($closeQuotes+1));
					else $attr = substr($fromSpace, 0, $nextSpace);
				} else $attr = substr($fromSpace, 0, $nextSpace);
				if (!$attr) $attr = $fromSpace;
				$attrSet[] = $attr;
				$tagLeft = substr($fromSpace, strlen($attr));
				$currentSpace = strpos($tagLeft, ' ');
			}
			$tagFound = in_array(strtolower($tagName), $this->tagsArray);			
			if ((!$tagFound && $this->tagsMethod) || ($tagFound && !$this->tagsMethod)) {
				if (!$isCloseTag) {
					$attrSet = $this->filterAttr($attrSet);
					$preTag .= '<' . $tagName;
					for ($i = 0; $i < count($attrSet); $i++)
						$preTag .= ' ' . $attrSet[$i];
					if (strpos($fromTagOpen, "</" . $tagName)) $preTag .= '>';
					else $preTag .= ' />';
			    } else $preTag .= '</' . $tagName . '>';
			}
			$postTag = substr($postTag, ($tagLength + 2));
			$tagOpen_start = strpos($postTag, '<');			
		}
		$preTag .= $postTag;
		return $preTag;
	}

	function filterAttr($attrSet) {	
		$newSet = array();
		for ($i = 0; $i < count($attrSet); $i++) {
			if (!$attrSet[$i]) continue;

           $attrSet[$i] = trim($attrSet[$i]);

 		   $exp = strpos($attrSet[$i], '=');
		   if ($exp === false) $attrSubSet = Array($attrSet[$i]); else {
		   $attrSubSet = Array();
           $attrSubSet[] = substr($attrSet[$i], 0, $exp);
           $attrSubSet[] = substr($attrSet[$i], $exp + 1);}
		   $attrSubSet[1] = stripslashes($attrSubSet[1]);


			list($attrSubSet[0]) = explode(' ', $attrSubSet[0]);
			
			if ((!eregi("^[a-z]*$",$attrSubSet[0])) || (($this->xssAuto) && ((in_array(strtolower($attrSubSet[0]), $this->attrBlacklist)) || (substr($attrSubSet[0], 0, 2) == 'on')))) 
				continue;
			if ($attrSubSet[1]) {
				$attrSubSet[1] = str_replace('&#', '', $attrSubSet[1]);
				$attrSubSet[1] = preg_replace('/\s+/', ' ', $attrSubSet[1]);
				$attrSubSet[1] = str_replace('"', '', $attrSubSet[1]);
				if ((substr($attrSubSet[1], 0, 1) == "'") && (substr($attrSubSet[1], (strlen($attrSubSet[1]) - 1), 1) == "'"))
					$attrSubSet[1] = substr($attrSubSet[1], 1, (strlen($attrSubSet[1]) - 2));
			}
			if (	((strpos(strtolower($attrSubSet[1]), 'expression') !== false) &&	(strtolower($attrSubSet[0]) == 'style')) ||
					(strpos(strtolower($attrSubSet[1]), 'javascript:') !== false) ||
					(strpos(strtolower($attrSubSet[1]), 'behaviour:') !== false) ||
					(strpos(strtolower($attrSubSet[1]), 'vbscript:') !== false) ||
					(strpos(strtolower($attrSubSet[1]), 'mocha:') !== false) ||
					(strpos(strtolower($attrSubSet[1]), 'livescript:') !== false) 
			) continue;
			$attrFound = in_array(strtolower($attrSubSet[0]), $this->attrArray);
			if ((!$attrFound && $this->attrMethod) || ($attrFound && !$this->attrMethod)) {
				if ($attrSubSet[1]) $newSet[] = $attrSubSet[0] . '="' . $attrSubSet[1] . '"';
				elseif ($attrSubSet[1] == "0") $newSet[] = $attrSubSet[0] . '="0"';
				else $newSet[] = $attrSubSet[0] . '="' . $attrSubSet[0] . '"';
			}	
		};
		return $newSet;
	}
	function decode($source) {
        $trans_tbl = get_html_translation_table(HTML_ENTITIES);
        $trans_tbl = array_flip($trans_tbl);
        $source = strtr($source, $trans_tbl);		
		$source = preg_replace('/&#x([a-f0-9]+);/mei',"chr(0x\\1)", $source);
		$source = str_replace("<<", "&lt;&lt;", $source );
		$source = str_replace("<>", "&lt;&gt;", $source );
		$source = str_replace(">>", "&gt;&gt;", $source );
		$source = preg_replace( "#\[code\](.+?)\[/code\]#ies", "\$this->regex_code_tag( '\\1' )", $source );
		return $source;
	}

	function safeSQL($source) {
		$source = (! get_magic_quotes_gpc ()) ? addslashes ($source) : $source;
		return mysql_escape_string($source);
	}

	function BB_Parse($source, $use_html=TRUE) {

		global $config_smilies, $config_http_home_url;

        $find= array(
					'/javascript:/si',
					'/about:/si',
					'/vbscript:/si',
					"'\[QUOTE\]'i",
					"'\[/QUOTE\]'i",
                    );

        $replace=array(
                      "javascript<b></b>:",
                      "about<b></b>:",
                      "vbscript<b></b>:",
					  "<!--QuoteBegin--><div class=\"quote\"><!--QuoteEBegin-->",
					  "<!--QuoteEnd--></div><!--QuoteEEnd-->",
                      );

		if ($use_html == false) {
        	$find[] 	= "'\r'";
			$replace[] 	= "";
        	$find[] 	= "'\n'";
			$replace[] 	= "<br />";
			}

        $smilies_arr = explode(",", $config_smilies);
        foreach($smilies_arr as $smile){
            $smile = trim($smile);
            $find[] = "':$smile:'";
            $replace[] = "<img style=\"border: none;\" alt=\"$smile\" align=\"absmiddle\" src=\"".$config_http_home_url."engine/data/emoticons/$smile.gif\" />";
		}

    $source = preg_replace($find,$replace,$source);

	$source = str_replace("`", "&#96;", $source ); 
	$source = str_replace("<?", "&lt;?", $source );
	$source = str_replace("?>", "?&gt;", $source );  

	$source = preg_replace( "#\[code\](.+?)\[/code\]#is", "<!--code1--><div class=\"scriptcode\"><!--ecode1-->\\1<!--code2--></div><!--ecode2-->", $source );
	$source = preg_replace( "#\[(left|right|center)\](.+?)\[/\\1\]#is"  , "<div align=\"\\1\">\\2</div>", $source );

	$source = preg_replace( "#\[b\](.+?)\[/b\]#is", "<b>\\1</b>", $source );
	$source = preg_replace( "#\[i\](.+?)\[/i\]#is", "<i>\\1</i>", $source );
	$source = preg_replace( "#\[u\](.+?)\[/u\]#is", "<u>\\1</u>", $source );
	$source = preg_replace( "#\[s\](.+?)\[/s\]#is", "<s>\\1</s>", $source );

	$source = preg_replace( "#\[url\](\S.+?)\[/url\]#ie"                                       , "\$this->regex_build_url(array('html' => '\\1', 'show' => '\\1'))", $source );
	$source = preg_replace( "#\[url\s*=\s*\&quot\;\s*(\S+?)\s*\&quot\;\s*\](.*?)\[\/url\]#ie" , "\$this->regex_build_url(array('html' => '\\1', 'show' => '\\2'))", $source );
	$source = preg_replace( "#\[url\s*=\s*(\S.+?)\s*\](.*?)\[\/url\]#ie"                       , "\$this->regex_build_url(array('html' => '\\1', 'show' => '\\2'))", $source );

	$source = preg_replace( "#\[email\](\S+?)\[/email\]#i"                                                                , "<a href=\"mailto:\\1\">\\1</a>", $source );
	$source = preg_replace( "#\[email\s*=\s*\&quot\;([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)\s*\&quot\;\s*\](.*?)\[\/email\]#i"  , "<a href=\"mailto:\\1\">\\2</a>", $source );
	$source = preg_replace( "#\[email\s*=\s*([\.\w\-]+\@[\.\w\-]+\.[\w\-]+)\s*\](.*?)\[\/email\]#i"                       , "<a href=\"mailto:\\1\">\\2</a>", $source );

	if (!$this->safe_mode) {
	$source = preg_replace( "#\[img\](.+?)\[/img\]#ie", "\$this->build_image('\\1')", $source );
	$source = preg_replace( "#\[img=(.+?)\](.+?)\[/img\]#ie", "\$this->build_image('\\2', '\\1')", $source );
	$source = preg_replace( "'\[thumb\]([^\[]*)([/\\\\])(.*?)\[/thumb\]'ie", "\$this->build_thumb('\$1\$2\$3', '\$1\$2thumbs\$2\$3')", $source );
	$source = preg_replace( "'\[thumb=(.*?)\]([^\[]*)([/\\\\])(.*?)\[/thumb\]'ie", "\$this->build_thumb('\$2\$3\$4', '\$2\$3thumbs\$3\$4', '\$1')", $source );
	}

	while( preg_match( "#\[color=([^\]]+)\](.+?)\[/color\]#ies", $source ) )
		{
		$source = preg_replace( "#\[color=([^\]]+)\](.+?)\[/color\]#ies"  , "\$this->regex_font_attr(array('s'=>'col' ,'1'=>'\\1','2'=>'\\2'))", $source );
		}

	return trim($source);

	}

function decodeBBCodes($txt, $use_html=TRUE, $wysiwig = "no") {

		global $config_smilies;

		$find = array (); $result = array ();

			$txt = preg_replace( "#<!--ThumbBegin-->(.+?)ShowBild\(\'(.+?)\'\)(.+?)<img align=['\"](.+?)['\"].+?"."<!--ThumbEnd-->#is", '\[THUMB=\\4]\\2\[/THUMB\]'         , $txt );
			$txt = preg_replace( "#<!--ThumbBegin-->(.+?)ShowBild\(\'(.+?)\'\)(.+?)<!--ThumbEnd-->#is", '\[THUMB]\\2\[/THUMB\]'         , $txt );
			$txt = preg_replace( "#<!--QuoteBegin-->(.+?)<!--QuoteEBegin-->#", '[QUOTE]'         , $txt );
			$txt = preg_replace( "#<!--QuoteEnd-->(.+?)<!--QuoteEEnd-->#"    , '[/QUOTE]'        , $txt );
			$txt = preg_replace( "#<!--code1-->(.+?)<!--ecode1-->#", '[code]' , $txt );
			$txt = preg_replace( "#<!--code2-->(.+?)<!--ecode2-->#", '[/code]', $txt );
			$txt = str_replace( '&nbsp;&nbsp;&nbsp;&nbsp;', "\t", $txt );
			$txt = str_replace( '&nbsp;&nbsp;'            , "  ", $txt );


		if ($wysiwig != "yes") {
			$txt = preg_replace( "#<i>(.+?)</i>#is"  , "\[I\]\\1\[/I\]"  , $txt );
			$txt = preg_replace( "#<b>(.+?)</b>#is"  , "\[B\]\\1\[/B\]"  , $txt );
			$txt = preg_replace( "#<s>(.+?)</s>#is"  , "\[S\]\\1\[/S\]"  , $txt );
			$txt = preg_replace( "#<u>(.+?)</u>#is"  , "\[U\]\\1\[/U\]"  , $txt );
			$txt = preg_replace( "#<center>(.+?)</center>#is", "\[CENTER\]\\1\[/CENTER\]"  , $txt );
			$txt = preg_replace( "#<img src=[\"'](\S+?)['\"] align=['\"](.+?)['\"].+?".">#is", "\[IMG=\\2\]\\1\[/IMG\]", $txt );
			$txt = preg_replace( "#<img src=[\"'](\S+?)['\"].+?".">#is", "\[IMG\]\\1\[/IMG\]", $txt );

			$txt = preg_replace( "#<a href=[\"'](http://|https://|ftp://|news://)?(\S.+?)['\"].+?".">(.+?)</a>#" , "\[URL=\\1\\2\]\\3\[/URL\]"  , $txt );
			$txt = preg_replace( "#<a href=[\"']mailto:(.+?)['\"]>(.+?)</a>#", "\[EMAIL=\\1\]\\2\[/EMAIL\]", $txt );

			while ( preg_match( "#<span style=['\"]color:(.+?)['\"]>(.+?)</span>#is", $txt ) )
			{
				$txt = preg_replace( "#<span style=['\"]color:(.+?)['\"]>(.+?)</span>#is"    , "\[COLOR=\\1\]\\2\[/COLOR\]", $txt );
			}
			while ( preg_match( "#<div align=['\"]left['\"]>(.+?)</div>#is", $txt ) )
			{
				$txt = preg_replace( "#<div align=['\"]left['\"]>(.+?)</div>#is"    , "\[LEFT]\\1\[/LEFT\]", $txt );
			}
			while ( preg_match( "#<div align=['\"]right['\"]>(.+?)</div>#is", $txt ) )
			{
				$txt = preg_replace( "#<div align=['\"]right['\"]>(.+?)</div>#is"    , "\[RIGHT]\\1\[/RIGHT\]", $txt );
			}
			while ( preg_match( "#<div align=['\"]center['\"]>(.+?)</div>#is", $txt ) )
			{
				$txt = preg_replace( "#<div align=['\"]center['\"]>(.+?)</div>#is"    , "\[CENTER]\\1\[/CENTER\]", $txt );
			}

		}

        $smilies_arr = explode(",", $config_smilies);
        foreach($smilies_arr as $smile){
            $smile = trim($smile);
            $replace[] = ":$smile:";
            $find[] = "#<img style=['\"]border: none;['\"] alt=['\"]".$smile."['\"] align=['\"]absmiddle['\"] src=['\"](.+?)".$smile.".gif['\"] />#is";
		}
			$txt = preg_replace( $find , $replace, $txt );

		if (!$use_html) {
		$txt = str_replace( "<br>"  , "\n", $txt );
		$txt = str_replace( "<br />", "\n", $txt );
		$txt = str_replace( "<BR>"  , "\n", $txt );
		$txt = str_replace( "<BR />", "\n", $txt );
		}

		$txt = htmlspecialchars($txt, ENT_QUOTES);
		if (!$use_html)	$txt = str_replace( "&amp;" , "&"   , $txt);

	return trim(stripslashes($txt));

	}

	function regex_font_attr( $IN )
	{
		if ( ! is_array($IN) )
		{
			return;
		}
		
		$style = $IN['1'];
		$text  = stripslashes($IN['2']);
		$type  = $IN['s'];
		
		$style = str_replace( '&quot;', '', $style );
		
		
		$style = preg_replace( "/[&\(\)\.\%\[\]<>\'\"]/", "", preg_replace( "#^(.+?)(?:;|$)#", "\\1", $style ) );
	
		if ($type == 'col')
		{
			$style = preg_replace( "/[^\d\w\#\s]/s", "", $style );
			return "<span style=\"color:".$style."\">".$text."</span>";
		}
		
	}

	function regex_build_url( $url=array() )
	{
		$skip_it = 0;
		
		if ( preg_match( "/([\.,\?]|&#33;)$/", $url['html'], $match) )
		{
			$url['end'] .= $match[1];
			$url['html'] = preg_replace( "/([\.,\?]|&#33;)$/", "", $url['html'] );
			$url['show'] = preg_replace( "/([\.,\?]|&#33;)$/", "", $url['show'] );
		}
		
		if (preg_match( "/\[\/(html|quote|code|sql)/i", $url['html']) )
		{
			return $url['html'];
		}
		
		$url['html'] = str_replace( "&amp;" , "&"   , $url['html'] );
		$url['html'] = str_replace( "["     , "%5b" , $url['html'] );
		$url['html'] = str_replace( "]"     , "%5d" , $url['html'] );
		
		$url['html'] = preg_replace( "/javascript:/i", "java script&#58; ", $url['html'] );
		
		
		if ( ! preg_match("#^(http|news|https|ftp|aim)://#", $url['html'] ) )
		{
			$url['html'] = 'http://'.$url['html'];
		}
		
		if ( preg_match( "/^<img src/i", $url['show'] ) )
		{
			$skip_it     = 1;
			$url['show'] = stripslashes($url['show']);
		}

		$url['show'] = preg_replace( "/&amp;/" , "&" , $url['show'] );
		$url['show'] = preg_replace( "/javascript:/i", "javascript&#58; ", $url['show'] );
		
		if ( (strlen($url['show']) -58 ) < 3 )  $skip_it = 1;
		
		if ( ! preg_match( "/^(http|ftp|https|news):\/\//i", $url['show'] )) $skip_it = 1;
		
		$show = $url['show'];
		
		if ($skip_it != 1)
		{
			$stripped = preg_replace( "#^(http|ftp|https|news)://(\S+)$#i", "\\2", $url['show'] );
			$uri_type = preg_replace( "#^(http|ftp|https|news)://(\S+)$#i", "\\1", $url['show'] );
			
			$show = $uri_type.'://'.substr( $stripped , 0, 35 ).'...'.substr( $stripped , -15   );
		}
		
		return $url['st'] . "<a href=\"".$url['html']."\" target=\"_blank\">".$show."</a>" . $url['end'];
	}

	function regex_code_tag($txt="")
	{		
		if ( $txt == "" )
		{
			return;
		}
		$txt = str_replace( "&lt;"      , "&#60;" , $txt );
		$txt = str_replace( "&gt;"      , "&#62;" , $txt );
		$txt = str_replace( "<"         , "&#60;" , $txt );
		$txt = str_replace( ">"         , "&#62;" , $txt );
		$txt = str_replace( "&quot;"    , "&#34;" , $txt );
		$txt = str_replace( "\\\""      , "&#34;" , $txt );
		$txt = str_replace( ":"         , "&#58;" , $txt );
		$txt = str_replace( "["         , "&#91;" , $txt );
		$txt = str_replace( "]"         , "&#93;" , $txt );
		$txt = str_replace( ")"         , "&#41;" , $txt );
		$txt = str_replace( "("         , "&#40;" , $txt );
		$txt = str_replace( "\r"        , "", $txt );
		$txt = str_replace( "\n"        , "<br />", $txt );
		$txt = preg_replace( "#\s{1};#" , "&#59;" , $txt );
		
		$txt = preg_replace( "#\t#"   , "&nbsp;&nbsp;&nbsp;&nbsp;", $txt );
		$txt = preg_replace( "#\s{2}#", "&nbsp;&nbsp;"            , $txt );

		return "[code]{$txt}[/code]";
	}

	function build_image($url="", $align="")
	{		
		$url   = trim($url);
		$align = trim($align);

		$url = str_replace('&amp;', '&', $url);
		$url = str_replace( " ", "%20", $url );
		$url = str_replace( "'", "", $url );
		$url = str_replace( '\"', "", $url );
		$url = str_replace( "<"         , "&#60;" , $url );
		$url = str_replace( ">"         , "&#62;" , $url );
		$align = htmlspecialchars(stripslashes($align), ENT_QUOTES);

		if ($align == '')
		return "<img src=\"$url\" style=\"border: none;\" />";
		else
		return "<img src=\"$url\" align=\"$align\" style=\"border: none;\" />";
	}

	function build_thumb($gurl="", $url="", $align="")
	{		
		$url   = trim($url);
		$align = trim($align);

		$url = str_replace('&amp;', '&', $url);
		$url = str_replace( " ", "%20", $url );
		$url = str_replace( "'", "", $url );
		$url = str_replace( '\"', "", $url );
		$url = str_replace( "<"         , "&#60;" , $url );
		$url = str_replace( ">"         , "&#62;" , $url );

		$gurl = str_replace('&amp;', '&', $gurl);
		$gurl = str_replace( " ", "%20", $gurl );
		$gurl = str_replace( "'", "", $gurl );
		$gurl = str_replace( '\"', "", $gurl );
		$gurl = str_replace( "<"         , "&#60;" , $gurl );
		$gurl = str_replace( ">"         , "&#62;" , $gurl );
		$align = htmlspecialchars(stripslashes($align), ENT_QUOTES);

		if ($align == '')
		return "<!--ThumbBegin--><a href=\"#\" onClick=\"ShowBild('$gurl'); return false;\" ><img src=\"$url\" style=\"border: none;\" alt=\" \" /></a><!--ThumbEnd-->";
		else
		return "<!--ThumbBegin--><a href=\"#\" onClick=\"ShowBild('$gurl'); return false;\" ><img align=\"$align\" src=\"$url\" style=\"border: none;\" alt=\" \" /></a><!--ThumbEnd-->";
	}
}
?>